<!DOCTYPE HTML>
<html>
    <head>

        <!-- Mobile Responsive Meta Tag -->
        <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

        <!-- Bootstrap -->
       <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">

        <title>CSS and Bootstrap Flex</title>

    </head>
    <body>

        <div class="text-center container-fluid">

            <h1>Bootstrap Flex</h1>
            <p>Use the d-flex class to create a flex container and transform direct children into flex items.</p>

            <h2>Centering elements</h2>
            <!-- d-flex means: d= display and flex= change properties into block level

             The "flex" value of the "display" property will change the element into a block-level flex container.
            - This will make all the child elements become "flexible" that allows them to occupy space enough for the content of an element and at the same time will have the elements appear beside each other.

            Will only work if we have the d-flex
            *justify content center = align horizontally
            *align-item-center= align vertically
             -->
            <div class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column" style="height:500px;">  
                <div class="bg-success p-3 h-25">Flex Item A</div>
                <div class="bg-warning p-3 h-25">Flex Item B</div>
                <div class="bg-danger p-3 h-25">Flex Item C</div>
            </div>

            <h2>Flex Row</h2>
            <div class="bg-dark p-3 d-flex">  
                <div class="p-3 bg-success">Flex Item A</div>
                <div class=" p-3 bg-danger">Flex Item B</div>
                <div class="p-3 bg-warning">Flex Item C</div>
            </div>

            <h2>Flex Row Reverse</h2>
            <div class="bg-dark p-3 d-flex flex-row-reverse">  
                <div class="p-3 bg-success">Flex Item A</div>
                <div class="p-3 bg-warning">Flex Item B</div>
                <div class="p-3 bg-danger">Flex Item C</div>
            </div>

            <h2>Creating Space Between Elements</h2>
            <div class="bg-dark p-3 d-md-flex justify-content-around">  
                <div class="p-3 bg-success col-md-2">Card A</div>
                <div class="p-3 bg-warning col-md-2">Card B</div>
                <div class="p-3 bg-danger col-md-2">Card C</div>
            </div>

            <h2>Flexbox With Margin</h2>
            <div class="bg-dark p-3 d-flex"> 

             <!-- - The "mr-auto" class will occupy the remaining width of it's parent container pushing all other elements inline. -->

                <div class="p-3 bg-success mr-auto">Flex Item A</div>
                <div class="p-3 bg-warning">Flex Item B</div>
                <div class="p-3 bg-danger">Flex Item C</div>
                <div class="p-3 bg-primary">Flex Item D</div>
            </div>

            <h2>Nested Flex Elements</h2>
            <div class=" bg-dark p-3 d-block d-md-flex">  
                <div class="p-3 bg-success mr-auto">Flex Item A</div>
                <div class="w-50 d-block d-md-flex justify-content-between">

                    <!-- - Unlike the "justify-content-around", the "justify-content-between" creates space between elements but removes the padding leftmost and rightmost padding of it's parent element. -->
                    
                    <div class="p-3 bg-warning">Flex Item B</div>
                    <div class="p-3 bg-danger">Flex Item C</div>
                    <div class="p-3 bg-primary">Flex Item D</div>
                </div>
            </div>

        </div>
        <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>
    </body>
</html>